# include "delstar.h"

void sort_lists (float *X, float *Y, int *S, int N) {

  int l,j,ir,i;
  double tX, tY, tS;
  
  l = N >> 1;
  ir = N - 1;
  for (;;) {
    if (l > 0) {
      l--;
      tX = X[l];
      tY = Y[l];
      tS = S[l];
    } else {
      tX = X[ir];
      X[ir] = X[0];
      tY = Y[ir];
      Y[ir] = Y[0];
      tS = S[ir];
      S[ir] = S[0];
      if (--ir == 0) {
	X[0] = tX;
	Y[0] = tY;
	S[0] = tS;
	return;
      }
    }
    i = l;
    j = (l << 1) + 1;
    while (j <= ir) {
      if (j < ir && X[j] < X[j+1]) j++;
      if (tX < X[j]) {
	X[i] = X[j];
	Y[i] = Y[j];
	S[i] = S[j];
	j += (i=j) + 1;
      }
      else j = ir + 1;
    }
    X[i] = tX;
    Y[i] = tY;
    S[i] = tS;
  }
}

